import { Connection, EntityManager, EntitySubscriberInterface, Repository } from 'typeorm';
import { ConfigModule, Constructor, MixinReturnType } from './types';
/**
 * @deprecated The definition files merging the entities types allow us to get rid of this util. It will be removed in the future
 * For repository context, you should extends repository and the medusa target repository.
 * Since it is not possible to use multiple extend, you can use that utilities to apply multiple extends.
 * @param source
 */
export declare function repositoryMixin<TEntity, TSource>(source: Constructor<TSource>): MixinReturnType<Repository<TEntity>, TSource>;
/**
 * Attach a new subscriber to a specific entities.
 * @param connection The database connection
 * @param Subscriber The subscriber to attach
 * @param transactionalEntityManager The transactional entity manager to pass the transaction through
 */
export declare function attachOrReplaceEntitySubscriber<T extends Constructor<EntitySubscriberInterface<unknown>>>(connection: Connection, Subscriber: T, transactionalEntityManager?: EntityManager): void;
/**
 * @deprecated Since this util only acts on the type and not the prototype itself, it adds more confusion for the user. It will be removed in the future
 * Allow to omit some property from a class.
 * @param Class
 * @param keys
 * @constructor
 */
export declare const Omit: <T, K extends keyof T>(Class: new () => T, keys: K[]) => new () => Omit<T, K>;
/**
 * Lower case the first character of the input string.
 * @param str
 */
export declare function lowerCaseFirst(str: string): string;
/**
 * Upper case the first character of the input string.
 * @param str
 */
export declare function upperCaseFirst(str: string): string;
export declare function buildRegexpIfValid(str: string): RegExp | undefined;
export declare function asyncLoadConfig(rootDir?: string, filename?: string): Promise<ConfigModule>;
